<?php

namespace Bank\Mellat\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bpRefundToPANRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:bpRefundToPANRequest
 * @subpackage Structs
 */
class BpRefundToPANRequest extends AbstractStructBase
{
    /**
     * The user
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $user;
    /**
     * The password
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $password;
    /**
     * The pan
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $pan;
    /**
     * The amount
     * @var int
     */
    public $amount;
    /**
     * The saleReferenceId
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var int
     */
    public $saleReferenceId;
    /**
     * The terminalId
     * @var int
     */
    public $terminalId;
    /**
     * Constructor method for bpRefundToPANRequest
     * @uses BpRefundToPANRequest::setUser()
     * @uses BpRefundToPANRequest::setPassword()
     * @uses BpRefundToPANRequest::setPan()
     * @uses BpRefundToPANRequest::setAmount()
     * @uses BpRefundToPANRequest::setSaleReferenceId()
     * @uses BpRefundToPANRequest::setTerminalId()
     * @param string $user
     * @param string $password
     * @param int $pan
     * @param int $amount
     * @param int $saleReferenceId
     * @param int $terminalId
     */
    public function __construct($user = null, $password = null, $pan = null, $amount = null, $saleReferenceId = null, $terminalId = null)
    {
        $this
            ->setUser($user)
            ->setPassword($password)
            ->setPan($pan)
            ->setAmount($amount)
            ->setSaleReferenceId($saleReferenceId)
            ->setTerminalId($terminalId);
    }
    /**
     * Get user value
     * @return string|null
     */
    public function getUser()
    {
        return $this->user;
    }
    /**
     * Set user value
     * @param string $user
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public function setUser($user = null)
    {
        // validation for constraint: string
        if (!is_null($user) && !is_string($user)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($user, true), gettype($user)), __LINE__);
        }
        $this->user = $user;
        return $this;
    }
    /**
     * Get password value
     * @return string|null
     */
    public function getPassword()
    {
        return $this->password;
    }
    /**
     * Set password value
     * @param string $password
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public function setPassword($password = null)
    {
        // validation for constraint: string
        if (!is_null($password) && !is_string($password)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($password, true), gettype($password)), __LINE__);
        }
        $this->password = $password;
        return $this;
    }
    /**
     * Get pan value
     * @return int|null
     */
    public function getPan()
    {
        return $this->pan;
    }
    /**
     * Set pan value
     * @param int $pan
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public function setPan($pan = null)
    {
        // validation for constraint: int
        if (!is_null($pan) && !(is_int($pan) || ctype_digit($pan))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($pan, true), gettype($pan)), __LINE__);
        }
        $this->pan = $pan;
        return $this;
    }
    /**
     * Get amount value
     * @return int|null
     */
    public function getAmount()
    {
        return $this->amount;
    }
    /**
     * Set amount value
     * @param int $amount
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: int
        if (!is_null($amount) && !(is_int($amount) || ctype_digit($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->amount = $amount;
        return $this;
    }
    /**
     * Get saleReferenceId value
     * @return int|null
     */
    public function getSaleReferenceId()
    {
        return $this->saleReferenceId;
    }
    /**
     * Set saleReferenceId value
     * @param int $saleReferenceId
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public function setSaleReferenceId($saleReferenceId = null)
    {
        // validation for constraint: int
        if (!is_null($saleReferenceId) && !(is_int($saleReferenceId) || ctype_digit($saleReferenceId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saleReferenceId, true), gettype($saleReferenceId)), __LINE__);
        }
        $this->saleReferenceId = $saleReferenceId;
        return $this;
    }
    /**
     * Get terminalId value
     * @return int|null
     */
    public function getTerminalId()
    {
        return $this->terminalId;
    }
    /**
     * Set terminalId value
     * @param int $terminalId
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public function setTerminalId($terminalId = null)
    {
        // validation for constraint: int
        if (!is_null($terminalId) && !(is_int($terminalId) || ctype_digit($terminalId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($terminalId, true), gettype($terminalId)), __LINE__);
        }
        $this->terminalId = $terminalId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Bank\Mellat\StructType\BpRefundToPANRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
