<?php

namespace Bank\Mellat\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bpSaleReferenceIdRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:bpSaleReferenceIdRequest
 * @subpackage Structs
 */
class BpSaleReferenceIdRequest extends AbstractStructBase
{
    /**
     * The terminalId
     * @var int
     */
    public $terminalId;
    /**
     * The userName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userName;
    /**
     * The userPassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userPassword;
    /**
     * The orderId
     * @var int
     */
    public $orderId;
    /**
     * The saleOrderId
     * @var int
     */
    public $saleOrderId;
    /**
     * Constructor method for bpSaleReferenceIdRequest
     * @uses BpSaleReferenceIdRequest::setTerminalId()
     * @uses BpSaleReferenceIdRequest::setUserName()
     * @uses BpSaleReferenceIdRequest::setUserPassword()
     * @uses BpSaleReferenceIdRequest::setOrderId()
     * @uses BpSaleReferenceIdRequest::setSaleOrderId()
     * @param int $terminalId
     * @param string $userName
     * @param string $userPassword
     * @param int $orderId
     * @param int $saleOrderId
     */
    public function __construct($terminalId = null, $userName = null, $userPassword = null, $orderId = null, $saleOrderId = null)
    {
        $this
            ->setTerminalId($terminalId)
            ->setUserName($userName)
            ->setUserPassword($userPassword)
            ->setOrderId($orderId)
            ->setSaleOrderId($saleOrderId);
    }
    /**
     * Get terminalId value
     * @return int|null
     */
    public function getTerminalId()
    {
        return $this->terminalId;
    }
    /**
     * Set terminalId value
     * @param int $terminalId
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequest
     */
    public function setTerminalId($terminalId = null)
    {
        // validation for constraint: int
        if (!is_null($terminalId) && !(is_int($terminalId) || ctype_digit($terminalId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($terminalId, true), gettype($terminalId)), __LINE__);
        }
        $this->terminalId = $terminalId;
        return $this;
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequest
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Get userPassword value
     * @return string|null
     */
    public function getUserPassword()
    {
        return $this->userPassword;
    }
    /**
     * Set userPassword value
     * @param string $userPassword
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequest
     */
    public function setUserPassword($userPassword = null)
    {
        // validation for constraint: string
        if (!is_null($userPassword) && !is_string($userPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userPassword, true), gettype($userPassword)), __LINE__);
        }
        $this->userPassword = $userPassword;
        return $this;
    }
    /**
     * Get orderId value
     * @return int|null
     */
    public function getOrderId()
    {
        return $this->orderId;
    }
    /**
     * Set orderId value
     * @param int $orderId
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequest
     */
    public function setOrderId($orderId = null)
    {
        // validation for constraint: int
        if (!is_null($orderId) && !(is_int($orderId) || ctype_digit($orderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($orderId, true), gettype($orderId)), __LINE__);
        }
        $this->orderId = $orderId;
        return $this;
    }
    /**
     * Get saleOrderId value
     * @return int|null
     */
    public function getSaleOrderId()
    {
        return $this->saleOrderId;
    }
    /**
     * Set saleOrderId value
     * @param int $saleOrderId
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequest
     */
    public function setSaleOrderId($saleOrderId = null)
    {
        // validation for constraint: int
        if (!is_null($saleOrderId) && !(is_int($saleOrderId) || ctype_digit($saleOrderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($saleOrderId, true), gettype($saleOrderId)), __LINE__);
        }
        $this->saleOrderId = $saleOrderId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Bank\Mellat\StructType\BpSaleReferenceIdRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
