<?php

namespace Bank\Mellat\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for bpVirtualPayRequest StructType
 * Meta information extracted from the WSDL
 * - type: tns:bpVirtualPayRequest
 * @subpackage Structs
 */
class BpVirtualPayRequest extends AbstractStructBase
{
    /**
     * The terminalId
     * @var int
     */
    public $terminalId;
    /**
     * The userName
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userName;
    /**
     * The userPassword
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $userPassword;
    /**
     * The orderId
     * @var int
     */
    public $orderId;
    /**
     * The amount
     * @var int
     */
    public $amount;
    /**
     * The localDate
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $localDate;
    /**
     * The localTime
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $localTime;
    /**
     * The additionalData
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $additionalData;
    /**
     * The callBackUrl
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $callBackUrl;
    /**
     * The payerId
     * @var int
     */
    public $payerId;
    /**
     * Constructor method for bpVirtualPayRequest
     * @uses BpVirtualPayRequest::setTerminalId()
     * @uses BpVirtualPayRequest::setUserName()
     * @uses BpVirtualPayRequest::setUserPassword()
     * @uses BpVirtualPayRequest::setOrderId()
     * @uses BpVirtualPayRequest::setAmount()
     * @uses BpVirtualPayRequest::setLocalDate()
     * @uses BpVirtualPayRequest::setLocalTime()
     * @uses BpVirtualPayRequest::setAdditionalData()
     * @uses BpVirtualPayRequest::setCallBackUrl()
     * @uses BpVirtualPayRequest::setPayerId()
     * @param int $terminalId
     * @param string $userName
     * @param string $userPassword
     * @param int $orderId
     * @param int $amount
     * @param string $localDate
     * @param string $localTime
     * @param string $additionalData
     * @param string $callBackUrl
     * @param int $payerId
     */
    public function __construct($terminalId = null, $userName = null, $userPassword = null, $orderId = null, $amount = null, $localDate = null, $localTime = null, $additionalData = null, $callBackUrl = null, $payerId = null)
    {
        $this
            ->setTerminalId($terminalId)
            ->setUserName($userName)
            ->setUserPassword($userPassword)
            ->setOrderId($orderId)
            ->setAmount($amount)
            ->setLocalDate($localDate)
            ->setLocalTime($localTime)
            ->setAdditionalData($additionalData)
            ->setCallBackUrl($callBackUrl)
            ->setPayerId($payerId);
    }
    /**
     * Get terminalId value
     * @return int|null
     */
    public function getTerminalId()
    {
        return $this->terminalId;
    }
    /**
     * Set terminalId value
     * @param int $terminalId
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setTerminalId($terminalId = null)
    {
        // validation for constraint: int
        if (!is_null($terminalId) && !(is_int($terminalId) || ctype_digit($terminalId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($terminalId, true), gettype($terminalId)), __LINE__);
        }
        $this->terminalId = $terminalId;
        return $this;
    }
    /**
     * Get userName value
     * @return string|null
     */
    public function getUserName()
    {
        return $this->userName;
    }
    /**
     * Set userName value
     * @param string $userName
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setUserName($userName = null)
    {
        // validation for constraint: string
        if (!is_null($userName) && !is_string($userName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userName, true), gettype($userName)), __LINE__);
        }
        $this->userName = $userName;
        return $this;
    }
    /**
     * Get userPassword value
     * @return string|null
     */
    public function getUserPassword()
    {
        return $this->userPassword;
    }
    /**
     * Set userPassword value
     * @param string $userPassword
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setUserPassword($userPassword = null)
    {
        // validation for constraint: string
        if (!is_null($userPassword) && !is_string($userPassword)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($userPassword, true), gettype($userPassword)), __LINE__);
        }
        $this->userPassword = $userPassword;
        return $this;
    }
    /**
     * Get orderId value
     * @return int|null
     */
    public function getOrderId()
    {
        return $this->orderId;
    }
    /**
     * Set orderId value
     * @param int $orderId
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setOrderId($orderId = null)
    {
        // validation for constraint: int
        if (!is_null($orderId) && !(is_int($orderId) || ctype_digit($orderId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($orderId, true), gettype($orderId)), __LINE__);
        }
        $this->orderId = $orderId;
        return $this;
    }
    /**
     * Get amount value
     * @return int|null
     */
    public function getAmount()
    {
        return $this->amount;
    }
    /**
     * Set amount value
     * @param int $amount
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setAmount($amount = null)
    {
        // validation for constraint: int
        if (!is_null($amount) && !(is_int($amount) || ctype_digit($amount))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($amount, true), gettype($amount)), __LINE__);
        }
        $this->amount = $amount;
        return $this;
    }
    /**
     * Get localDate value
     * @return string|null
     */
    public function getLocalDate()
    {
        return $this->localDate;
    }
    /**
     * Set localDate value
     * @param string $localDate
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setLocalDate($localDate = null)
    {
        // validation for constraint: string
        if (!is_null($localDate) && !is_string($localDate)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localDate, true), gettype($localDate)), __LINE__);
        }
        $this->localDate = $localDate;
        return $this;
    }
    /**
     * Get localTime value
     * @return string|null
     */
    public function getLocalTime()
    {
        return $this->localTime;
    }
    /**
     * Set localTime value
     * @param string $localTime
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setLocalTime($localTime = null)
    {
        // validation for constraint: string
        if (!is_null($localTime) && !is_string($localTime)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($localTime, true), gettype($localTime)), __LINE__);
        }
        $this->localTime = $localTime;
        return $this;
    }
    /**
     * Get additionalData value
     * @return string|null
     */
    public function getAdditionalData()
    {
        return $this->additionalData;
    }
    /**
     * Set additionalData value
     * @param string $additionalData
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setAdditionalData($additionalData = null)
    {
        // validation for constraint: string
        if (!is_null($additionalData) && !is_string($additionalData)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($additionalData, true), gettype($additionalData)), __LINE__);
        }
        $this->additionalData = $additionalData;
        return $this;
    }
    /**
     * Get callBackUrl value
     * @return string|null
     */
    public function getCallBackUrl()
    {
        return $this->callBackUrl;
    }
    /**
     * Set callBackUrl value
     * @param string $callBackUrl
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setCallBackUrl($callBackUrl = null)
    {
        // validation for constraint: string
        if (!is_null($callBackUrl) && !is_string($callBackUrl)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($callBackUrl, true), gettype($callBackUrl)), __LINE__);
        }
        $this->callBackUrl = $callBackUrl;
        return $this;
    }
    /**
     * Get payerId value
     * @return int|null
     */
    public function getPayerId()
    {
        return $this->payerId;
    }
    /**
     * Set payerId value
     * @param int $payerId
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public function setPayerId($payerId = null)
    {
        // validation for constraint: int
        if (!is_null($payerId) && !(is_int($payerId) || ctype_digit($payerId))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($payerId, true), gettype($payerId)), __LINE__);
        }
        $this->payerId = $payerId;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \Bank\Mellat\StructType\BpVirtualPayRequest
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
